<?php
/**
* Plugin WDDquickpost
*
* @package	PLX
* @version	1.0
* @date	16/09/16
* @author Bronco
**/
class WDDquickpost extends plxPlugin {

	private $cats; #string
	private $catId; #string

	public function __construct($default_lang) {
		
		# appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);		
		
		# limite l'acces a l'ecran de configuration du plugin
		# PROFIL_ADMIN , PROFIL_MANAGER , PROFIL_MODERATOR , PROFIL_EDITOR , PROFIL_WRITER
		$this->setConfigProfil(PROFIL_ADMIN);
		
		
		# Declaration d'un hook (existant ou nouveau)
		$this->addHook('IndexBegin','IndexBegin');
		$this->addHook('AdminIndexPrepend','AdminIndexPrepend');
		$this->addHook('AdminPrepend','AdminPrepend');
		$this->addHook('AdminArticlePrepend','AdminArticlePrepend');
		$this->addHook('AdminArticleFoot','AdminArticleFoot');
		//$this->addHook('AdminArticleTop','AdminArticleTop');
		$this->addHook('plxAdminEditArticle','plxAdminEditArticle');
		$this->addHook('plxAdminEditArticleXml','plxAdminEditArticleXml');
		$this->addHook('AdminArticleContent','AdminArticleContent');
		$this->addHook('AdminProfilTop','AdminProfilTop');
		$this->addHook('AdminArticlePreview','AdminArticlePreview');
		$this->addHook('AdminArticleParseData','AdminArticleParseData');
		$this->addHook('AdminArticlePostData','AdminArticlePostData');
		$this->addHook('AdminArticleInitData','AdminArticleInitData');
		$this->addHook('plxShowLastArtListContent','plxShowLastArtListContent');
		$this->addHook('plxMotorParseArticle','plxMotorParseArticle');
		$this->addHook('showBookmarkletPost','showBookmarkletPost');
		$this->addHook('getTagList','getTagList');
		$this->addHook('showLinksPageLink','showLinksPageLink');
		$this->addHook('showLinkedURL','showLinkedURL');
		$this->addHook('showquickpostRSSLink','showquickpostRSSLink');
		$this->addHook('plxFeedRssArticlesXml','plxFeedRssArticlesXml');
		
	}

	########################################
	# HOOKS
	########################################





	########################################
	# IndexBegin
	########################################
	# Description:
	public function IndexBegin(){
		global $plxMotor,$plxPlugins,$plxShow,$plxToken;
		
		if (empty($_SESSION['user'])){ # pas connecté
			$pw_input    ='<label>Mot de passe</label><input type="password" name="password"/>';
			$action      =PLX_CORE.'admin/auth.php';
			
		}else{ # connecté
			$pw_input    ='';
			$action      =PLX_CORE.'admin/article.php';
			
		}

		#gestion de la génération du formulaire si on vient du bookmarklet
		if (!empty($_GET['source'])&&$_GET['source']=='bookmarkletquickpost'){
			$artId                         = $this->newIdArticle();
			$token                         = sha1(mt_rand(0, 1000000));
			$_SESSION['formtoken'][$token] = time();
			$token                         ='<input name="token" value="'.$token.'" type="hidden" />';				
			$login                         = $plxMotor->aUsers[strip_tags($_GET['user'])]['login'];
			$media_link					   ="
			var title = 'medias';window.open('".PLX_CORE."admin/medias.php','','menubar=no,height=' + screen.height +',width=' + screen.width+',toolbar=no,scrollbars=auto,status=no,top=0,left=0');
			";
			

			echo '<html><head><title>Poster un article sur le site</title><meta http-equiv="Content-Type" content="text/html; charset=utf-8" />';
			echo '
			
			<link rel="stylesheet" href="./'.$plxShow->plxMotor->aConf['racine_themes'].$plxShow->plxMotor->style.'/css/theme.css"/>
			<link rel="stylesheet" href="./'.$plxShow->plxMotor->aConf['racine_themes'].$plxShow->plxMotor->style.'/css/admin.css"/>
			<link rel="stylesheet" href="./'.$plxShow->plxMotor->aConf['racine_themes'].$plxShow->plxMotor->style.'/css/plucss.css"/>
			<link rel="stylesheet" href="'.PLX_PLUGINS.'WDDquickpost/style.css"/>';
			
			echo '</head><body><div class="container quickpost">
			
				<h1> Poster un article sur le site </h1>
				<form action="'.$action.'" method="post" enctype="multipart/form-data" >
					'.$token.'
					<input type="hidden" name="source" value="bookmarkletquickpost"/>
					<input type="hidden" name="login" value="'. $login.'"/>
					<input type="hidden" name="author" value="'.$_GET['user'].'"/>

					<input type="hidden" name="date_publication_day" value="'.date('d').'"/>
					<input type="hidden" name="date_publication_day" value="'.date('d').'"/>
					<input type="hidden" name="date_creation_day" value="'.date('d').'"/>
					<input type="hidden" name="date_update_day" value="'.date('d').'"/>

					<input type="hidden" name="date_publication_month" value="'.date('m').'"/>
					<input type="hidden" name="date_creation_month" value="'.date('m').'"/>
					<input type="hidden" name="date_update_month" value="'.date('m').'"/>

					<input type="hidden" name="date_publication_year" value="'.date('Y').'"/>
					<input type="hidden" name="date_creation_year" value="'.date('Y').'"/>
					<input type="hidden" name="date_update_year" value="'.date('Y').'"/>

					<input type="hidden" name="date_publication_time" value="'.date('H:i').'"/>
					<input type="hidden" name="date_creation_time" value="'.date('H:i').'"/>
					<input type="hidden" name="date_update_time" value="'.date('H:i').'"/>

					<input type="hidden" name="new_catname" value=""/>
					<input type="hidden" name="title_htmltag" value=""/>
					<input type="hidden" name="meta_description" value=""/>
					<input type="hidden" name="meta_keywords" value=""/>
					<input type="hidden" name="artId" value="'.$artId.'"/>
					<input type="hidden" name="thumbnail_title" value=""/>
					<input type="hidden" name="thumbnail_alt" value="image titre"/>
					<input type="hidden" name="url" value=""/>
					<input type="hidden" name="url_link" value=""/>
					
					<input type="hidden" name="template" value="article.php"/>';
					
					# password #####
					echo $pw_input;
					################
					
					echo '<fieldset>
					<label>Titre</label>
					<input type="text" name="title" value="'.strip_tags($_GET['title']).'" placeholder="Titre du post"/>
					<label>Image</label>
					<input type="file" name="thumbnail" value="" placeholder="image d\'illustration: http://www.domain.fr/image.png"  accept="image/*"/>
					<input type="url" name="image" value="" list="tags_list" placeholder="http://image.com/a/recuperer"/>
					</fieldset>
					<fieldset>
					<label>Chapo</label>';

					eval($plxShow->callHook("markdownBar","#id_chapo"));

					echo'
					 	<textarea id="id_chapo" name="chapo" placeholder="Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit "></textarea>
					 	<div class="emotes_list" target="#id_chapo">';

					# emotes #####					
					eval($plxShow->callHook("WDD_replace_list","active_emotes"));					
					##############
					
					echo '</div></fieldset><fieldset><label>Contenu du post</label>';

					eval($plxShow->callHook("markdownBar","#id_content"));

					echo'	<textarea id="id_content" name="content" placeholder="Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum."></textarea>
					 	<small>pour insérer des vidéos/des liens/des images, il suffit de coller leur adresse</small>
					 	<div class="emotes_list" target="#id_content">';

					# emotes #####
					eval($plxShow->callHook("WDD_replace_list","active_emotes"));
					##############
					echo '</div><label><input type="checkbox" name="allow_com" value="1" checked/> Commentaires</label></fieldset><fieldset><label>Tags</label>
						<input type="text" name="tags" value="" list="tags_list" placeholder="tag1,tag2..."/>
					 	<datalist id="tags_list">'.$this->getTagList().'</datalist>
					 <br/>
					<label>Catégories</label>
					<div class="cat_list">';
						$cats=$plxMotor->aCats;		
						foreach ($cats as $id => $data) {
							echo '<span><input type="checkbox" id="cat'.$id.'" value="'.$id.'" name="catId[]"/><label for="cat'.$id.'">'.$data['name'].'</label></span>'."\n";
						}
							
					echo '</div></fieldset>
					 <div class="save-fixed">
					 	<input type="button" onclick="'.$media_link.';return false;" value="&#9712; Medias"/>
					 	<input type="submit" name="publish" value="☀ Publier (public)"/>
					 	<input type="submit" name="draft"   value="✋ Brouillon (privé)"/>
					 </div>';
					

					eval($plxShow->callHook("WDD_replace_js"));
					eval($plxShow->callHook("markdownJs"));
					eval($plxShow->callHook("markdownAssets"));
				echo '</form>
				</div></body></html>
			';
			exit();
		}
		
	}

	########################################
	# AdminPrepend
	########################################
	# Description:
	public function AdminPrepend(){
		
		echo '<?php
		
		if (!empty($_POST["source"])&&empty($_SESSION["post"])){ 			
			$_SESSION["post"]=$_POST;
			if (!empty($_FILES["thumbnail"])){
				$_SESSION["files"]=$_FILES;
			}			
		}
		
		?>';
	}
	########################################
	# AdminIndexPrepend
	########################################
	# Description:
	public function AdminIndexPrepend(){
		# redirige vers article.php après une connexion via le bookmarklet
		echo '<?php 
		if (!empty($_SESSION["post"])||!empty($_POST["source"])){ 			
			header("location: '.PLX_CORE.'admin/article.php");
		}
		
		?>';
	}

	########################################
	# AdminArticlePrepend
	########################################
	public function AdminArticlePrepend(){

		if (empty($_POST['source']) && !empty($_SESSION['post'])){
			$_POST=$_SESSION['post'];
		}
		if (empty($_FILES['thumbnail']) && !empty($_SESSION['files'])){
			$_FILES['thumbnail']=$_SESSION['files'];
		}

		# on vient de poster via le bookmarklet ?
		if (!empty($_POST['source'])&&$_POST['source']=='bookmarkletquickpost'){			
			# Si on a posté une image d'illustration, on gère l'upload
			if (!empty($_FILES['thumbnail']["name"])&&empty($_FILES['error'])){
				$dest_path=PLX_ROOT.'data/medias/images/';
				if (!is_dir($dest_path)){mkdir($dest_path);}
				$tmp=$_FILES['thumbnail']['tmp_name'];
				$fil=explode('?',strip_tags(basename($_FILES['thumbnail']['name'])));
				$fil=$fil[0];
				$fil=plxUtils::title2url(strip_tags($_POST['title'])).'-'.$fil;
				$loc=$dest_path.'/'.$fil;

				if (stripos($_FILES['thumbnail']['type'],'image/')!==false){
					rename ($tmp,$loc);	
					chmod($loc,0644);
					$_FILES['thumbnail']['name']=$loc;
				}else{$_FILES['thumbnail']['name']="";}
			}
			
			$_POST['url']=plxUtils::title2url($_POST['url']).uniqid();
			$_POST['content']=nl2br($_POST['content']);
			
			# gestion des données du formulaire
			if (!empty($_FILES['thumbnail']["name"])){
				echo '<?php $_POST["thumbnail"]="'.$_FILES['thumbnail']["name"].'";?>';
			}elseif (!empty(trim($_POST['image']))){
				# si on a fourni l'url d'une image, on la récupère en local
				$_POST['image']=strip_tags($_POST['image']);
				$dest_path=PLX_ROOT.'data/medias/images/';
				$fil=explode('?',basename($_POST['image']));
				$fil=$fil[0];
				$fil=plxUtils::title2url(strip_tags($_POST['title'])).'-'.$fil;
				$loc=$dest_path.'/'.$fil;
				$image=file_get_contents($_POST['image']);
				$_POST['content'].='<div class="img_source"><a href="'.$_POST['image'].'">Source image</a></div>';
				if ($image){
					file_put_contents($loc,$image);
					chmod($loc,0644);
					echo '<?php $_POST["thumbnail"]="data/medias/images/'.$fil.'"; ?>';
				}else{
					echo '<?php $_POST["thumbnail"]=""; ?>';
				}
			}
			echo '
			<?php if(!empty($_POST) && !isset($_POST["url_link"])) {$_POST["url_link"]="";}	?>
			';

			unset($_SESSION["post"]);
			$_SESSION['close_bookmarklet']=true;
			unset($_FILES);
		}
		
	}

	##############################################################################
	# AdminArticleFoot
	##############################################################################
	# ferme le bookmarklet
	public function AdminArticleFoot(){
		if (!empty($_SESSION['close_bookmarklet'])){
			unset($_SESSION['close_bookmarklet']);
			echo '<script>window.close();</script>';
		}
	}

	##############################################################################
	# plxFeedRssArticlesXml
	##############################################################################
	# transforme le flux rss pour intégrer l'url associée à l'article et ajouter le permalink
	public function plxFeedRssArticlesXml(){
		echo '<?php
				$thumb=""; 
				if ($this->plxRecord_arts->f("thumbnail")!=""){$thumb=\'<img src="\'.$this->plxRecord_arts->f("thumbnail").\'" style="width:100%;height:auto"/>\';}
				$entry="";
				$entry .= "\t<item>\n";
				$entry .= "\t\t"."<title>".plxUtils::strCheck($this->plxRecord_arts->f("title"))."</title> "."\n";
				$entry .= "\t\t"."<link>".$this->plxRecord_arts->f("url_link")."</link>"."\n";
				$entry .= "\t\t"."<guid>".$this->urlRewrite("?article".$artId."/".$this->plxRecord_arts->f("url"))."</guid>"."\n";
				$entry .= "\t\t"."<description>".$thumb.plxUtils::strCheck(plxUtils::rel2abs($this->racine,$content))."<br/><hr/><a href=\"./?article".$artId."#comments\" title=\"commenter ou voir les commentaires sur ce lien\"><small>&#9658; Commentaires</small></a></description>\n";
				$entry .= "\t\t"."<permalink>".$this->urlRewrite("?article".$artId."/".$this->plxRecord_arts->f("url"))."</permalink>"."\n";
				$entry .= "\t\t"."<pubDate>".plxDate::dateIso2rfc822($this->plxRecord_arts->f("date"))."</pubDate>"."\n";
				$entry .= "\t\t"."<dc:creator>".plxUtils::strCheck($author)."</dc:creator>"."\n";
				
				$entry .= "\t</item>\n";

				?>';
	}

	##############################################################################
	# plxAdminEditArticleXml
	##############################################################################
	# Ajoute le stockage de l'adresse du lien dans le fichier de l'article
	public function plxAdminEditArticleXml(){
		echo '<?php 
					$url_link = plxUtils::getValue($content["url_link"]);
					$xml .= "\t<url_link><![CDATA[".plxUtils::cdataCheck(trim($url_link))."]]></url_link>\n";
					$xml = str_replace("../../","",$xml); # corriger le problème de chemin relatif (sale mais j\'ai pas trouvé mieux :-/)
				?>';
	}

	##############################################################################
	# plxAdminEditArticle
	##############################################################################
	# Récupère le fichier image s'il y en a
	public function plxAdminEditArticle(){
		echo '<?php
				if (empty($content["date_update_old"])){
					$content["date_update_old"]=$content["date_creation_year"].$content["date_creation_month"].$content["date_creation_day"].substr(str_replace(":","",$content["date_creation_time"]),0,4);;
				}
				?>';
		
	}




	##############################################################################
	# plxMotorParseArticle
	##############################################################################
	# Gestion de l'url dans le parsing d'un article
	public function plxMotorParseArticle(){
		echo '<?php 
		if (!empty($iTags["url_link"])){
			$art["url_link"] = $values[$iTags["url_link"][0]]["value"];
		}else{
			$art["url_link"] = "";
		}

		?>';
	}



	##############################################################################
	# AdminArticleContent
	##############################################################################
	# Ajout d'un input sur la page admin pour gérer le lien associé à un article
	public function AdminArticleContent(){
		$label=$this->getLang("L_ARTICLE_URL_LINK");
		echo '
					<div class="sml-12">
						<label for="id_url_link">'.$label.':</label>
						<?php plxUtils::printInput("url_link",plxUtils::strCheck($url_link),"url","27-255",false,"full-width"); ?>
					</div>
				';
		}



	##############################################################################
	# AdminArticlePreview
	##############################################################################
	# Gestion du lien dans la prévisualisation d'un article	
	public function AdminArticlePreview(){
		echo '<?php	$art["url_link"] = plxUtils::strCheck($_POST["url_link"]);?>';
	}

	##############################################################################
	# AdminArticlePostData
	##############################################################################
	# Gestion du lien posté dans l'article et upload éventuel de l'image
	public function AdminArticlePostData(){
		echo '<?php	$url_link = plxUtils::strCheck($_POST["url_link"]);?>';
		
	}

	##############################################################################
	# 4 AdminArticleParseData
	##############################################################################
	# Ajout de la variable $url_link (édition d'un article)
	public function AdminArticleParseData(){
		echo '<?php 
			if (!isset($result["url_link"])){
				$url_link="";
			}else{
				$url_link=$result["url_link"];
			}
		?>';
	}

	##############################################################################
	# 5 AdminArticleInitData (création d'un article)
	##############################################################################
	# Ajout de la variable $url_link lors de l'initialisation
	public function AdminArticleInitData(){
		echo '<?php	$url_link = "";?>';
	}


	########################################
	# AdminProfilTop
	########################################
	# Description:
	public function AdminProfilTop(){
		$this->showBookmarkletPost();
	}



	########################################
	# plxShowLastArtListContent
	########################################
	# Retire les articles ayant un lien associé de la liste des derniers articles
	public function plxShowLastArtListContent(){
		echo '
		<?php if (!empty($art["url_link"])){
			$row =str_replace(" class=\""," class=\"weblink ",$row);
			$row = str_replace("#url_link",$art["url_link"],$row);
		} ?>
		';
	}



	########################################
	# showBookmarkletPost
	########################################
	# Description:
	public function showBookmarkletPost(){
		global $plxMotor,$plxAdmin;
		if (empty($plxMotor->racine)){
			$root=$plxAdmin->racine;
		}else{
			$root=$plxMotor->racine;
		}
		echo '<style>
				#profil .WDDquickpostBookmarklet{
				    padding:15px;
				    background:rgba(0,0,0,0.2);
				    list-style:none;
				    margin:5px;
				    display:inline-block;
				}
				#profil .WDDquickpostBookmarklet *{
				    vertical-align:middle;
				}
				#profil .WDDquickpostBookmarklet img{
				    width:32px;height:auto;
				}
			</style>';
		echo '<li class="WDDquickpostBookmarklet"><a href="javascript:javascript:(function(){var url = location.href;var title = document.title || url;window.open(\''.$root.'?url=\' + encodeURIComponent(url)+\'&user='.$_SESSION['user'].'\'+\'&title=\' + encodeURIComponent(title)+\'&source=bookmarkletquickpost\',\'mybookmarklet\',\'\');})();" title="'.$this->getLang('L_DRAG_THIS_LINK').'"><img src="'.PLX_PLUGINS.'WDDquickpost/icon.png"> '.$this->getLang('L_POST_AN_ARTICLE').'</a></li>';
	}

	########################################
	# Private methods
	########################################
	private function getTagList($tags_array=false){
		global $plxMotor;$tags=array();
		foreach($plxMotor->aTags as $article){
			$tag=array_flip(array_map('trim',explode(',',$article['tags'])));
			$tags=array_merge($tags,$tag);
		}
		if (!$tags_array){
			$taglist='';
			foreach($tags as $tag=>$osef){if (!empty($tag)){$taglist.='<option value="'.$tag.'">'.$tag.'</option>';}}
	 		return $taglist;
	 	}
	 	return $tags;
	}

	private function newIdArticle(){
		global $plxMotor;
		$arts=$plxMotor->activeArts;		
		$max=0;
		foreach ($arts as $id => $data) {
			$max=max($max,intval($id));
		}
		$max++;
		$max="$max";
		$max=str_repeat('0', 4-strlen($max)).$max;
		return $max;
			
	}	


}





/* Pense-bete:
 * Récuperer des parametres du fichier parameters.xml
 *	$this->getParam("<nom du parametre>")
 *	$this-> setParam ("param1", 12345, "numeric")
 *	$this->saveParams()
 *
 *	plxUtils::strCheck($string) : sanitize string
 *
 * 
 * Quelques constantes utiles: 
 * PLX_CORE
 * PLX_ROOT
 * PLX_CHARSET
 * PLX_CONFIG_PATH
 * PLX_PLUGINS
 * PLX_CONFIG_PATH
 * PLX_ADMIN (true si on est dans admin)
 * PLX_CHARSET
 * PLX_VERSION
 * PLX_FEED
 *
 * Appel de HOOK dans un thème
 *	eval($plxShow->callHook("showLinkedURL","param1"))  ou eval($plxShow->callHook("ThemeEndHead",array("param1","param2")))
 *	ou $retour=$plxShow->callHook("ThemeEndHead","param1"));
 */